scala.tools.nsc.backend.icode.ICodeCheckers

# ICodeChecker

###
Related Doc: package ICodeCheckers

#### class ICodeChecker extends AnyRef

This class performs a set of checks similar to what the bytecode verifier does. For each basic block, it checks that:

- for primitive operations: the type and numer of operands match the type of the operation

- for method calls: the method exists in the type of the receiver and the number and type of arguments match the declared type of the method.

- for object creation: the constructor can be called.

- for load/stores: the field/local/param exists and the type of the value matches that of the target.

For a control flow graph it checks that type stacks at entry to each basic block 'agree':

- they have the same length
- there exists a lub for all types at the same position in stacks.

Source
  ICodeCheckers.scala
Version

  1.0, 06/09/2005

To do

  Iulian says: I think there's some outdated logic in the checker. The issue with exception handlers being special for least upper bounds pointed out some refactoring in the lattice class. Maybe a worthwhile refactoring would be to make the checker use the DataFlowAnalysis class, and use the lattice trait. In the implementation of LUB, there's a flag telling if one of the successors is 'exceptional'. The inliner is using this mechanism.

  ,

  Better checks for `MONITOR_ENTER/EXIT` Better checks for local var initializations

Linear Supertypes
AnyRef, Any
Known Subclasses
icodeChecker
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. ICodeChecker
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new ICodeChecker()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from ICodeChecker to any2stringadd[ICodeChecker] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (ICodeChecker, B)

   Implicit information
     This member is added by an implicit conversion from ICodeChecker to ArrowAssoc[ICodeChecker] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

7. #### def check(b: Global.icodes.BasicBlock, initial: Global.icodes.TypeStack): Global.icodes.TypeStack

   Check the basic block to be type correct and return the produced type stack.

8. #### def check(c: Global.icodes.Code): Unit

9. #### def check(m: Global.icodes.IMethod): Unit

10. #### def check(cls: Global.icodes.IClass): Unit

11. #### def checkICodes(): Unit

12. #### var clasz: Global.icodes.IClass

13. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

14. #### var code: Global.icodes.Code

15. #### def defaultInstrPrinter: () ⇒ String

16. #### val emptyStack: Global.icodes.TypeStack

17. #### def ensuring(cond: (ICodeChecker) ⇒ Boolean, msg: ⇒ Any): ICodeChecker

    Implicit information
      This member is added by an implicit conversion from ICodeChecker to Ensuring[ICodeChecker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

18. #### def ensuring(cond: (ICodeChecker) ⇒ Boolean): ICodeChecker

    Implicit information
      This member is added by an implicit conversion from ICodeChecker to Ensuring[ICodeChecker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

19. #### def ensuring(cond: Boolean, msg: ⇒ Any): ICodeChecker

    Implicit information
      This member is added by an implicit conversion from ICodeChecker to Ensuring[ICodeChecker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

20. #### def ensuring(cond: Boolean): ICodeChecker

    Implicit information
      This member is added by an implicit conversion from ICodeChecker to Ensuring[ICodeChecker] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

21. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

23. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

24. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from ICodeChecker to StringFormat[ICodeChecker] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

25. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

26. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

27. #### def icodeError(msg: String, stack: Global.icodes.TypeStack): Unit

28. #### def icodeError(msg: String): Unit

29. #### val in: Map[Global.icodes.BasicBlock, Global.icodes.TypeStack]

30. #### def initMaps(bs: Seq[Global.icodes.BasicBlock]): Unit

31. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

32. #### def logChecker(msg: String): Unit

    A wrapper to route log messages to debug output also.

33. #### def meet(bl: Global.icodes.BasicBlock): Unit

    Apply the meet operator of the stack lattice on bl's predecessors.

    Apply the meet operator of the stack lattice on bl's predecessors. :-). Compute the input to bl by checking that all stacks have the same length, and taking the lub of types at the same positions.

34. #### var method: Global.icodes.IMethod

35. #### def mkInstrPrinter(f: (Int) ⇒ String): () ⇒ String

    A couple closure creators to reduce noise in the output: when multiple items are pushed or popped, this lets us print something short and sensible for those beyond the first.

36. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

37. #### def notChecked(ts: Global.icodes.TypeStack): Boolean

    The presence of emptyStack means that path has not yet been checked (and may not be empty).

38. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

39. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

40. #### val out: Map[Global.icodes.BasicBlock, Global.icodes.TypeStack]

41. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

42. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

43. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

44. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

45. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

46. #### def →[B](y: B): (ICodeChecker, B)

    Implicit information
      This member is added by an implicit conversion from ICodeChecker to ArrowAssoc[ICodeChecker] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from ICodeChecker to any2stringadd[ICodeChecker]

### Inherited by implicit conversion StringFormat from ICodeChecker to StringFormat[ICodeChecker]

### Inherited by implicit conversion Ensuring from ICodeChecker to Ensuring[ICodeChecker]

### Inherited by implicit conversion ArrowAssoc from ICodeChecker to ArrowAssoc[ICodeChecker]

### Ungrouped